import javax.swing.*;
import java.awt.*;

/**
 * A visualisation of an agent.
 * 
 * @author David J. Barnes
 * @version 2009.04.21
 */
public class AgentView extends JButton
{
    private static Color ON_COLOUR = Color.BLUE;
    private static Color OFF_COLOUR = Color.YELLOW;
    
    /**
     * Constructor for objects of class AgentView
     */
    public AgentView()
    {
       super();
       setMinimumSize(new Dimension(8, 8));
       setOpaque(true);
       setState(false);
    }

    /**
     * Set the color depending on the agent's state.
     */
    public void setState(boolean state)
    {
        if(state) {
            setBackground(ON_COLOUR);
        }
        else {
            setBackground(OFF_COLOUR);
        }
    }
}
