package malaria;

import static repast.simphony.relogo.Utility.*;
import static repast.simphony.relogo.UtilityG.*;
import java.util.Collection;
import java.util.HashSet;
import java.util.Set;
import groovy.lang.Closure;
import repast.simphony.relogo.*;
import repast.simphony.relogo.builder.GeneratedByReLogoBuilder;
import repast.simphony.relogo.builder.ReLogoBuilderGeneratedFor;
import repast.simphony.space.SpatialException;
import repast.simphony.space.grid.Grid;
import repast.simphony.space.grid.GridPoint;

@GeneratedByReLogoBuilder
@SuppressWarnings({"unused","rawtypes","unchecked"})
public class ReLogoTurtle extends BaseTurtle{

	/**
	 * Makes a number of new userTurtles and then executes a set of commands on the
	 * created userTurtles.
	 * 
	 * @param number
	 *            a number
	 * @param closure
	 *            a set of commands
	 * @return created userTurtles
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserTurtle")
	public AgentSet<malaria.relogo.UserTurtle> hatchUserTurtles(int number, Closure closure) {
		AgentSet<malaria.relogo.UserTurtle> result = new AgentSet<>();
		AgentSet<Turtle> createResult = this.hatch(number,closure,"UserTurtle");
		for (Turtle t : createResult){
			if (t instanceof malaria.relogo.UserTurtle){
				result.add((malaria.relogo.UserTurtle)t);
			}
		} 
		return result;
	}

	/**
	 * Makes a number of new userTurtles and then executes a set of commands on the
	 * created userTurtles.
	 * 
	 * @param number
	 *            a number
	 * @param closure
	 *            a set of commands
	 * @return created userTurtles
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserTurtle")
	public AgentSet<malaria.relogo.UserTurtle> hatchUserTurtles(int number) {
		return hatchUserTurtles(number,null);
	}

	/**
	 * Returns an agentset of userTurtles from the patch of the caller.
	 * 
	 * @return agentset of userTurtles from the caller's patch
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserTurtle")
	public AgentSet<malaria.relogo.UserTurtle> userTurtlesHere(){
	  Grid grid = getMyObserver().getGrid();
	  GridPoint gridPoint = grid.getLocation(this);
	  AgentSet<malaria.relogo.UserTurtle> result = new AgentSet<malaria.relogo.UserTurtle>();
	  for (Turtle t : Utility.getTurtlesOnGridPoint(gridPoint,getMyObserver(),"userTurtle")){
			if (t instanceof malaria.relogo.UserTurtle)
			result.add((malaria.relogo.UserTurtle)t);
		}
		return result;
	}

	/**
	 * Returns the agentset of userTurtles on the patch at the direction (ndx, ndy) from the
	 * caller.
	 * 
	 * @param nX
	 *            a number
	 * @param nY
	 *            a number
	 * @returns agentset of userTurtles at the direction (nX, nY) from the caller
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserTurtle")
	public AgentSet<malaria.relogo.UserTurtle> userTurtlesAt(Number nX, Number nY){
		double dx = nX.doubleValue();
		double dy = nY.doubleValue();
		double[] displacement = {dx,dy};

		try{
		GridPoint gridPoint = Utility.getGridPointAtDisplacement(getTurtleLocation(),displacement,getMyObserver());
		AgentSet<malaria.relogo.UserTurtle> result = new AgentSet<malaria.relogo.UserTurtle>();						
		for (Turtle t : Utility.getTurtlesOnGridPoint(gridPoint,getMyObserver(),"userTurtle")){
			if (t instanceof malaria.relogo.UserTurtle)
			result.add((malaria.relogo.UserTurtle)t);
		}
		return result;
		}
		catch(SpatialException e){
			return new AgentSet<malaria.relogo.UserTurtle>();
		}
	}

	/**
	 * Returns an agentset of userTurtles on a given patch.
	 * 
	 * @param p
	 *            a patch
	 * @return agentset of userTurtles on patch p
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserTurtle")
	public AgentSet<malaria.relogo.UserTurtle> userTurtlesOn(Patch p){
		AgentSet<malaria.relogo.UserTurtle> result = new AgentSet<malaria.relogo.UserTurtle>();						
		for (Turtle t : Utility.getTurtlesOnGridPoint(p.getGridLocation(),getMyObserver(),"userTurtle")){
			if (t instanceof malaria.relogo.UserTurtle)
			result.add((malaria.relogo.UserTurtle)t);
		}
		return result;
	}

	/**
	 * Returns an agentset of userTurtles on the same patch as a turtle.
	 * 
	 * @param t
	 *            a turtle
	 * @return agentset of userTurtles on the same patch as turtle t
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserTurtle")
	public AgentSet<malaria.relogo.UserTurtle> userTurtlesOn(Turtle t){
		AgentSet<malaria.relogo.UserTurtle> result = new AgentSet<malaria.relogo.UserTurtle>();						
		for (Turtle tt : Utility.getTurtlesOnGridPoint(Utility.ndPointToGridPoint(t.getTurtleLocation()),getMyObserver(),"userTurtle")){
			if (tt instanceof malaria.relogo.UserTurtle)
			result.add((malaria.relogo.UserTurtle)tt);
		}
		return result;
	}

	/**
	 * Returns an agentset of userTurtles on the patches in a collection or on the patches
	 * that a collection of turtles are.
	 * 
	 * @param a
	 *            a collection
	 * @return agentset of userTurtles on the patches in collection a or on the patches
	 *         that collection a turtles are
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserTurtle")
	public AgentSet<malaria.relogo.UserTurtle> userTurtlesOn(Collection c){

		if (c == null || c.isEmpty()){
			return new AgentSet<malaria.relogo.UserTurtle>();
		}

		Set<malaria.relogo.UserTurtle> total = new HashSet<malaria.relogo.UserTurtle>();
		if (c.iterator().next() instanceof Turtle){
			for (Object o : c){
				if (o instanceof Turtle){
					Turtle t = (Turtle) o;
					total.addAll(userTurtlesOn(t));
				}
			}
		}
		else {
			for (Object o : c){
				if (o instanceof Patch){
					Patch p = (Patch) o;
					total.addAll(userTurtlesOn(p));
				}
			}
		}
		return new AgentSet<malaria.relogo.UserTurtle>(total);
	}

	/**
	 * Queries if object is a userTurtle.
	 * 
	 * @param o
	 *            an object
	 * @return true or false based on whether the object is a userTurtle
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserTurtle")
	public boolean isUserTurtleQ(Object o){
		return (o instanceof malaria.relogo.UserTurtle);
	}

	/**
	 * Returns an agentset containing all userTurtles.
	 * 
	 * @return agentset of all userTurtles
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserTurtle")
	public AgentSet<malaria.relogo.UserTurtle> userTurtles(){
		AgentSet<malaria.relogo.UserTurtle> a = new AgentSet<malaria.relogo.UserTurtle>();
		for (Object e : this.getMyObserver().getContext().getObjects(malaria.relogo.UserTurtle.class)) {
			if (e instanceof malaria.relogo.UserTurtle){
				a.add((malaria.relogo.UserTurtle)e);
			}
		}
		return a;
	}

	/**
	 * Returns the userTurtle with the given who number.
	 * 
	 * @param number
	 *            a number
	 * @return turtle number
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserTurtle")
	public malaria.relogo.UserTurtle userTurtle(Number number){
		Turtle turtle = Utility.turtleU(number.intValue(), getMyObserver());
		if (turtle instanceof malaria.relogo.UserTurtle)
			return (malaria.relogo.UserTurtle) turtle;
		return null;
	}

	/**
	 * Makes a number of new mosquitoes and then executes a set of commands on the
	 * created mosquitoes.
	 * 
	 * @param number
	 *            a number
	 * @param closure
	 *            a set of commands
	 * @return created mosquitoes
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.Mosquito")
	public AgentSet<malaria.relogo.Mosquito> hatchMosquitoes(int number, Closure closure) {
		AgentSet<malaria.relogo.Mosquito> result = new AgentSet<>();
		AgentSet<Turtle> createResult = this.hatch(number,closure,"Mosquito");
		for (Turtle t : createResult){
			if (t instanceof malaria.relogo.Mosquito){
				result.add((malaria.relogo.Mosquito)t);
			}
		} 
		return result;
	}

	/**
	 * Makes a number of new mosquitoes and then executes a set of commands on the
	 * created mosquitoes.
	 * 
	 * @param number
	 *            a number
	 * @param closure
	 *            a set of commands
	 * @return created mosquitoes
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.Mosquito")
	public AgentSet<malaria.relogo.Mosquito> hatchMosquitoes(int number) {
		return hatchMosquitoes(number,null);
	}

	/**
	 * Returns an agentset of mosquitoes from the patch of the caller.
	 * 
	 * @return agentset of mosquitoes from the caller's patch
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.Mosquito")
	public AgentSet<malaria.relogo.Mosquito> mosquitoesHere(){
	  Grid grid = getMyObserver().getGrid();
	  GridPoint gridPoint = grid.getLocation(this);
	  AgentSet<malaria.relogo.Mosquito> result = new AgentSet<malaria.relogo.Mosquito>();
	  for (Turtle t : Utility.getTurtlesOnGridPoint(gridPoint,getMyObserver(),"mosquito")){
			if (t instanceof malaria.relogo.Mosquito)
			result.add((malaria.relogo.Mosquito)t);
		}
		return result;
	}

	/**
	 * Returns the agentset of mosquitoes on the patch at the direction (ndx, ndy) from the
	 * caller.
	 * 
	 * @param nX
	 *            a number
	 * @param nY
	 *            a number
	 * @returns agentset of mosquitoes at the direction (nX, nY) from the caller
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.Mosquito")
	public AgentSet<malaria.relogo.Mosquito> mosquitoesAt(Number nX, Number nY){
		double dx = nX.doubleValue();
		double dy = nY.doubleValue();
		double[] displacement = {dx,dy};

		try{
		GridPoint gridPoint = Utility.getGridPointAtDisplacement(getTurtleLocation(),displacement,getMyObserver());
		AgentSet<malaria.relogo.Mosquito> result = new AgentSet<malaria.relogo.Mosquito>();						
		for (Turtle t : Utility.getTurtlesOnGridPoint(gridPoint,getMyObserver(),"mosquito")){
			if (t instanceof malaria.relogo.Mosquito)
			result.add((malaria.relogo.Mosquito)t);
		}
		return result;
		}
		catch(SpatialException e){
			return new AgentSet<malaria.relogo.Mosquito>();
		}
	}

	/**
	 * Returns an agentset of mosquitoes on a given patch.
	 * 
	 * @param p
	 *            a patch
	 * @return agentset of mosquitoes on patch p
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.Mosquito")
	public AgentSet<malaria.relogo.Mosquito> mosquitoesOn(Patch p){
		AgentSet<malaria.relogo.Mosquito> result = new AgentSet<malaria.relogo.Mosquito>();						
		for (Turtle t : Utility.getTurtlesOnGridPoint(p.getGridLocation(),getMyObserver(),"mosquito")){
			if (t instanceof malaria.relogo.Mosquito)
			result.add((malaria.relogo.Mosquito)t);
		}
		return result;
	}

	/**
	 * Returns an agentset of mosquitoes on the same patch as a turtle.
	 * 
	 * @param t
	 *            a turtle
	 * @return agentset of mosquitoes on the same patch as turtle t
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.Mosquito")
	public AgentSet<malaria.relogo.Mosquito> mosquitoesOn(Turtle t){
		AgentSet<malaria.relogo.Mosquito> result = new AgentSet<malaria.relogo.Mosquito>();						
		for (Turtle tt : Utility.getTurtlesOnGridPoint(Utility.ndPointToGridPoint(t.getTurtleLocation()),getMyObserver(),"mosquito")){
			if (tt instanceof malaria.relogo.Mosquito)
			result.add((malaria.relogo.Mosquito)tt);
		}
		return result;
	}

	/**
	 * Returns an agentset of mosquitoes on the patches in a collection or on the patches
	 * that a collection of turtles are.
	 * 
	 * @param a
	 *            a collection
	 * @return agentset of mosquitoes on the patches in collection a or on the patches
	 *         that collection a turtles are
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.Mosquito")
	public AgentSet<malaria.relogo.Mosquito> mosquitoesOn(Collection c){

		if (c == null || c.isEmpty()){
			return new AgentSet<malaria.relogo.Mosquito>();
		}

		Set<malaria.relogo.Mosquito> total = new HashSet<malaria.relogo.Mosquito>();
		if (c.iterator().next() instanceof Turtle){
			for (Object o : c){
				if (o instanceof Turtle){
					Turtle t = (Turtle) o;
					total.addAll(mosquitoesOn(t));
				}
			}
		}
		else {
			for (Object o : c){
				if (o instanceof Patch){
					Patch p = (Patch) o;
					total.addAll(mosquitoesOn(p));
				}
			}
		}
		return new AgentSet<malaria.relogo.Mosquito>(total);
	}

	/**
	 * Queries if object is a mosquito.
	 * 
	 * @param o
	 *            an object
	 * @return true or false based on whether the object is a mosquito
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.Mosquito")
	public boolean isMosquitoQ(Object o){
		return (o instanceof malaria.relogo.Mosquito);
	}

	/**
	 * Returns an agentset containing all mosquitoes.
	 * 
	 * @return agentset of all mosquitoes
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.Mosquito")
	public AgentSet<malaria.relogo.Mosquito> mosquitoes(){
		AgentSet<malaria.relogo.Mosquito> a = new AgentSet<malaria.relogo.Mosquito>();
		for (Object e : this.getMyObserver().getContext().getObjects(malaria.relogo.Mosquito.class)) {
			if (e instanceof malaria.relogo.Mosquito){
				a.add((malaria.relogo.Mosquito)e);
			}
		}
		return a;
	}

	/**
	 * Returns the mosquito with the given who number.
	 * 
	 * @param number
	 *            a number
	 * @return turtle number
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.Mosquito")
	public malaria.relogo.Mosquito mosquito(Number number){
		Turtle turtle = Utility.turtleU(number.intValue(), getMyObserver());
		if (turtle instanceof malaria.relogo.Mosquito)
			return (malaria.relogo.Mosquito) turtle;
		return null;
	}

	/**
	 * Makes a number of new humans and then executes a set of commands on the
	 * created humans.
	 * 
	 * @param number
	 *            a number
	 * @param closure
	 *            a set of commands
	 * @return created humans
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.Human")
	public AgentSet<malaria.relogo.Human> hatchHumans(int number, Closure closure) {
		AgentSet<malaria.relogo.Human> result = new AgentSet<>();
		AgentSet<Turtle> createResult = this.hatch(number,closure,"Human");
		for (Turtle t : createResult){
			if (t instanceof malaria.relogo.Human){
				result.add((malaria.relogo.Human)t);
			}
		} 
		return result;
	}

	/**
	 * Makes a number of new humans and then executes a set of commands on the
	 * created humans.
	 * 
	 * @param number
	 *            a number
	 * @param closure
	 *            a set of commands
	 * @return created humans
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.Human")
	public AgentSet<malaria.relogo.Human> hatchHumans(int number) {
		return hatchHumans(number,null);
	}

	/**
	 * Returns an agentset of humans from the patch of the caller.
	 * 
	 * @return agentset of humans from the caller's patch
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.Human")
	public AgentSet<malaria.relogo.Human> humansHere(){
	  Grid grid = getMyObserver().getGrid();
	  GridPoint gridPoint = grid.getLocation(this);
	  AgentSet<malaria.relogo.Human> result = new AgentSet<malaria.relogo.Human>();
	  for (Turtle t : Utility.getTurtlesOnGridPoint(gridPoint,getMyObserver(),"human")){
			if (t instanceof malaria.relogo.Human)
			result.add((malaria.relogo.Human)t);
		}
		return result;
	}

	/**
	 * Returns the agentset of humans on the patch at the direction (ndx, ndy) from the
	 * caller.
	 * 
	 * @param nX
	 *            a number
	 * @param nY
	 *            a number
	 * @returns agentset of humans at the direction (nX, nY) from the caller
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.Human")
	public AgentSet<malaria.relogo.Human> humansAt(Number nX, Number nY){
		double dx = nX.doubleValue();
		double dy = nY.doubleValue();
		double[] displacement = {dx,dy};

		try{
		GridPoint gridPoint = Utility.getGridPointAtDisplacement(getTurtleLocation(),displacement,getMyObserver());
		AgentSet<malaria.relogo.Human> result = new AgentSet<malaria.relogo.Human>();						
		for (Turtle t : Utility.getTurtlesOnGridPoint(gridPoint,getMyObserver(),"human")){
			if (t instanceof malaria.relogo.Human)
			result.add((malaria.relogo.Human)t);
		}
		return result;
		}
		catch(SpatialException e){
			return new AgentSet<malaria.relogo.Human>();
		}
	}

	/**
	 * Returns an agentset of humans on a given patch.
	 * 
	 * @param p
	 *            a patch
	 * @return agentset of humans on patch p
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.Human")
	public AgentSet<malaria.relogo.Human> humansOn(Patch p){
		AgentSet<malaria.relogo.Human> result = new AgentSet<malaria.relogo.Human>();						
		for (Turtle t : Utility.getTurtlesOnGridPoint(p.getGridLocation(),getMyObserver(),"human")){
			if (t instanceof malaria.relogo.Human)
			result.add((malaria.relogo.Human)t);
		}
		return result;
	}

	/**
	 * Returns an agentset of humans on the same patch as a turtle.
	 * 
	 * @param t
	 *            a turtle
	 * @return agentset of humans on the same patch as turtle t
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.Human")
	public AgentSet<malaria.relogo.Human> humansOn(Turtle t){
		AgentSet<malaria.relogo.Human> result = new AgentSet<malaria.relogo.Human>();						
		for (Turtle tt : Utility.getTurtlesOnGridPoint(Utility.ndPointToGridPoint(t.getTurtleLocation()),getMyObserver(),"human")){
			if (tt instanceof malaria.relogo.Human)
			result.add((malaria.relogo.Human)tt);
		}
		return result;
	}

	/**
	 * Returns an agentset of humans on the patches in a collection or on the patches
	 * that a collection of turtles are.
	 * 
	 * @param a
	 *            a collection
	 * @return agentset of humans on the patches in collection a or on the patches
	 *         that collection a turtles are
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.Human")
	public AgentSet<malaria.relogo.Human> humansOn(Collection c){

		if (c == null || c.isEmpty()){
			return new AgentSet<malaria.relogo.Human>();
		}

		Set<malaria.relogo.Human> total = new HashSet<malaria.relogo.Human>();
		if (c.iterator().next() instanceof Turtle){
			for (Object o : c){
				if (o instanceof Turtle){
					Turtle t = (Turtle) o;
					total.addAll(humansOn(t));
				}
			}
		}
		else {
			for (Object o : c){
				if (o instanceof Patch){
					Patch p = (Patch) o;
					total.addAll(humansOn(p));
				}
			}
		}
		return new AgentSet<malaria.relogo.Human>(total);
	}

	/**
	 * Queries if object is a human.
	 * 
	 * @param o
	 *            an object
	 * @return true or false based on whether the object is a human
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.Human")
	public boolean isHumanQ(Object o){
		return (o instanceof malaria.relogo.Human);
	}

	/**
	 * Returns an agentset containing all humans.
	 * 
	 * @return agentset of all humans
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.Human")
	public AgentSet<malaria.relogo.Human> humans(){
		AgentSet<malaria.relogo.Human> a = new AgentSet<malaria.relogo.Human>();
		for (Object e : this.getMyObserver().getContext().getObjects(malaria.relogo.Human.class)) {
			if (e instanceof malaria.relogo.Human){
				a.add((malaria.relogo.Human)e);
			}
		}
		return a;
	}

	/**
	 * Returns the human with the given who number.
	 * 
	 * @param number
	 *            a number
	 * @return turtle number
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.Human")
	public malaria.relogo.Human human(Number number){
		Turtle turtle = Utility.turtleU(number.intValue(), getMyObserver());
		if (turtle instanceof malaria.relogo.Human)
			return (malaria.relogo.Human) turtle;
		return null;
	}

	/**
	 * Makes a directed userLink from a turtle to the caller then executes a set of
	 * commands on the created userLink.
	 * 
	 * @param t
	 *            a turtle
	 * @param closure
	 *            a set of commands
	 * @return created userLink
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserLink")
	public malaria.relogo.UserLink createUserLinkFrom(Turtle t, Closure closure){
		malaria.relogo.UserLink link = (malaria.relogo.UserLink)this.getMyObserver().getNetwork("UserLink").addEdge(t,this);
		if (closure != null){
			this.ask(link,closure);
		}
		return link;
	}

	/**
	 * Makes a directed userLink from a turtle to the caller.
	 * 
	 * @param t
	 *            a turtle
	 * @return created userLink
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserLink")
	public malaria.relogo.UserLink createUserLinkFrom(Turtle t){
			return createUserLinkFrom(t,null);
	}

	/**
	 * Makes directed userLinks from a collection to the caller then executes a set
	 * of commands on the created userLinks.
	 * 
	 * @param a
	 *            a collection
	 * @param closure
	 *            a set of commands
	 * @return created userLinks
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserLink")
	public AgentSet<malaria.relogo.UserLink> createUserLinksFrom(Collection<? extends Turtle> a, Closure closure){
		AgentSet<malaria.relogo.UserLink> links = new AgentSet<malaria.relogo.UserLink>();
		for(Turtle t : a){
			links.add((malaria.relogo.UserLink)this.getMyObserver().getNetwork("UserLink").addEdge(t,this));
		}
		if (closure != null){
			this.ask(links,closure);
		}
		return links;
	}

	/**
	 * Makes directed userLinks from a collection to the caller.
	 * 
	 * @param a
	 *            a collection
	 * @return created userLinks
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserLink")
	public AgentSet<malaria.relogo.UserLink> createUserLinksFrom(Collection<? extends Turtle> a){
		return createUserLinksFrom(a,null);
	}

	/**
	 * Makes a directed userLink to a turtle from the caller then executes a set of
	 * commands on the created userLink.
	 * 
	 * @param t
	 *            a turtle
	 * @param closure
	 *            a set of commands
	 * @return created userLink
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserLink")
	public malaria.relogo.UserLink createUserLinkTo(Turtle t, Closure closure){
		malaria.relogo.UserLink link = (malaria.relogo.UserLink)this.getMyObserver().getNetwork("UserLink").addEdge(this,t);
		if (closure != null){
			this.ask(link,closure);
		}
		return link;
	}

	/**
	 * Makes a directed userLink to a turtle from the caller.
	 * 
	 * @param t
	 *            a turtle
	 * @return created userLink
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserLink")
	public malaria.relogo.UserLink createUserLinkTo(Turtle t){
			return createUserLinkTo(t,null);
	}

	/**
	 * Makes directed userLinks to a collection from the caller then executes a set
	 * of commands on the created userLinks.
	 * 
	 * @param a
	 *            a collection
	 * @param closure
	 *            a set of commands
	 * @return created userLinks
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserLink")
	public AgentSet<malaria.relogo.UserLink> createUserLinksTo(Collection<? extends Turtle> a, Closure closure){
		AgentSet<malaria.relogo.UserLink> links = new AgentSet<malaria.relogo.UserLink>();
		for(Object t : a){
			if (t instanceof Turtle){
				links.add((malaria.relogo.UserLink)this.getMyObserver().getNetwork("UserLink").addEdge(this,(Turtle)t));
			}
		}
		if (closure != null){
			this.ask(links,closure);
		}
		return links;
	}

	/**
	 * Makes directed userLinks to a collection from the caller.
	 * 
	 * @param a
	 *            a collection
	 * @return created userLinks
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserLink")
	public AgentSet<malaria.relogo.UserLink> createUserLinksTo(Collection<? extends Turtle> a){
		return createUserLinksTo(a,null);
	}

	/**
	 * Queries if there is a directed userLink from a turtle to the caller.
	 * 
	 * @param t
	 *            a turtle
	 * @return true or false based on whether there is a directed userLink from
	 *         turtle t to the caller
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserLink")
	public boolean inUserLinkNeighborQ(Turtle t){
		return this.getMyObserver().getNetwork("UserLink").isPredecessor(t, this);
	}

	/**
	 * Returns the agentset with directed userLinks to the caller.
	 * 
	 * @return agentset with directed userLinks to the caller
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserLink")
	public AgentSet inUserLinkNeighbors(){
		AgentSet result = new AgentSet();
		for(Object o : this.getMyObserver().getNetwork("UserLink").getPredecessors(this)){
			result.add(o);
		}
		return result;
	}

	/**
	 * Returns the directed userLink from a turtle to the caller.
	 * 
	 * @param t
	 *            a turtle
	 * @return directed userLink from turtle t to the caller
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserLink")
	public malaria.relogo.UserLink inUserLinkFrom(Turtle t){
		return (malaria.relogo.UserLink)this.getMyObserver().getNetwork("UserLink").getEdge(t,this);
	}

	/**
	 * Returns an agentset of directed userLinks from other turtles to the caller.
	 * 
	 * @return agentset of directed userLinks from other turtles to the caller
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserLink")
	public AgentSet<malaria.relogo.UserLink> myInUserLinks(){
		AgentSet<malaria.relogo.UserLink> result = new AgentSet<malaria.relogo.UserLink>();
		for(Object o :  this.getMyObserver().getNetwork("UserLink").getInEdges(this)){
			if (o instanceof malaria.relogo.UserLink){
				result.add((malaria.relogo.UserLink) o);
			}
		}
		return result;
	}

	/**
	 * Returns an agentset of directed userLinks to other turtles from the caller.
	 * 
	 * @return agentset of directed userLinks to other turtles from the caller
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserLink")
	public AgentSet<malaria.relogo.UserLink> myOutUserLinks(){
		AgentSet<malaria.relogo.UserLink> result = new AgentSet<malaria.relogo.UserLink>();
		for(Object o :  this.getMyObserver().getNetwork("UserLink").getOutEdges(this)){
			if (o instanceof malaria.relogo.UserLink){
				result.add((malaria.relogo.UserLink) o);
			}
		}
		return result;
	}

	/**
	 * Queries if there is a directed userLink to a turtle from the caller.
	 * 
	 * @param t
	 *            a turtle
	 * @return true or false based on whether there is a directed userLink to
	 *         turtle t from the caller
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserLink")
	public boolean outUserLinkNeighborQ(Turtle t){
		return this.getMyObserver().getNetwork("UserLink").isPredecessor(this, t);
	}

	/**
	 * Returns the agentset with directed userLinks from the caller.
	 * 
	 * @return agentset with directed userLinks from the caller
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserLink")
	public AgentSet outUserLinkNeighbors(){
		AgentSet result = new AgentSet();
		for(Object o : this.getMyObserver().getNetwork("UserLink").getSuccessors(this)){
			result.add(o);
		}
		return result;
	}

	/**
	 * Returns the directed userLink to a turtle from the caller.
	 * 
	 * @param t
	 *            a turtle
	 * @return directed userLink to turtle t from the caller
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserLink")
	public malaria.relogo.UserLink outUserLinkTo(Turtle t){
		return (malaria.relogo.UserLink)this.getMyObserver().getNetwork("UserLink").getEdge(this, t);
	}

	/**
	 * Reports true if there is a userLink connecting t and the caller.
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserLink")
	public boolean userLinkNeighborQ(Turtle t){
		return this.getMyObserver().getNetwork("UserLink").isAdjacent(this, t);
	}

	/**
	 * Returns the agentset of all turtles found at the other end of
	 * userLinks connected to the calling turtle.
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserLink")
	public AgentSet userLinkNeighbors(){
		AgentSet result = new AgentSet();
		for(Object o : this.getMyObserver().getNetwork("UserLink").getAdjacent(this)){
			result.add(o);
		}
		return result;
	}

	/**
	 * Returns an agentset of the caller's userLinks.
	 * 
	 * @return agentset of the caller's userLinks
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserLink")
	public AgentSet<malaria.relogo.UserLink> myUserLinks(){
		AgentSet<malaria.relogo.UserLink> result = new AgentSet<malaria.relogo.UserLink>();
		for(Object o : this.getMyObserver().getNetwork("UserLink").getEdges(this)){
			if (o instanceof malaria.relogo.UserLink){
				result.add((malaria.relogo.UserLink)o);
			}
		}
		return result;
	}

	/**
	 * Queries if object is a userLink.
	 * 
	 * @param o
	 *            an object
	 * @return true or false based on whether the object is a userLink
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserLink")
	public boolean isUserLinkQ(Object o){
		return (o instanceof malaria.relogo.UserLink);
	}

	/**
	 * Returns an agentset containing all userLinks.
	 * 
	 * @return agentset of all userLinks
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserLink")
	public AgentSet<malaria.relogo.UserLink> userLinks(){
		AgentSet<malaria.relogo.UserLink> a = new AgentSet<malaria.relogo.UserLink>();
		for (Object e : this.getMyObserver().getContext().getObjects(malaria.relogo.UserLink.class)) {
			if (e instanceof malaria.relogo.UserLink){
				a.add((malaria.relogo.UserLink)e);
			}
		}
		return a;
	}

	/**
	 * Returns the userLink between two turtles.
	 * 
	 * @param oneEnd
	 *            an integer
	 * @param otherEnd
	 *            an integer
	 * @return userLink between two turtles
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserLink")
	public malaria.relogo.UserLink userLink(Number oneEnd, Number otherEnd) {
		return (malaria.relogo.UserLink)(this.getMyObserver().getNetwork("UserLink").getEdge(turtle(oneEnd),turtle(otherEnd)));
	}

	/**
	 * Returns the userLink between two turtles.
	 * 
	 * @param oneEnd
	 *            a turtle
	 * @param otherEnd
	 *            a turtle
	 * @return userLink between two turtles
	 */
	@ReLogoBuilderGeneratedFor("malaria.relogo.UserLink")
	public malaria.relogo.UserLink userLink(Turtle oneEnd, Turtle otherEnd) {
		return userLink(oneEnd.getWho(), otherEnd.getWho());
	}

	/**
	 * Returns the value of the global variable humanInitialInfectionProbability.
	 *
	 * @return the value of the global variable humanInitialInfectionProbability
	 */
	@ReLogoBuilderGeneratedFor("global: humanInitialInfectionProbability")
	public Object getHumanInitialInfectionProbability(){
		return repast.simphony.relogo.ReLogoModel.getInstance().getModelParam("humanInitialInfectionProbability");
	}

	/**
	 * Sets the value of the global variable humanInitialInfectionProbability.
	 *
	 * @param value
	 *            a value
	 */
	@ReLogoBuilderGeneratedFor("global: humanInitialInfectionProbability")
	public void setHumanInitialInfectionProbability(Object value){
		repast.simphony.relogo.ReLogoModel.getInstance().setModelParam("humanInitialInfectionProbability",value);
	}

	/**
	 * Returns the value of the global variable humanInfectionPeriod.
	 *
	 * @return the value of the global variable humanInfectionPeriod
	 */
	@ReLogoBuilderGeneratedFor("global: humanInfectionPeriod")
	public Object getHumanInfectionPeriod(){
		return repast.simphony.relogo.ReLogoModel.getInstance().getModelParam("humanInfectionPeriod");
	}

	/**
	 * Sets the value of the global variable humanInfectionPeriod.
	 *
	 * @param value
	 *            a value
	 */
	@ReLogoBuilderGeneratedFor("global: humanInfectionPeriod")
	public void setHumanInfectionPeriod(Object value){
		repast.simphony.relogo.ReLogoModel.getInstance().setModelParam("humanInfectionPeriod",value);
	}

	/**
	 * Returns the value of the global variable humanMaximumMovement.
	 *
	 * @return the value of the global variable humanMaximumMovement
	 */
	@ReLogoBuilderGeneratedFor("global: humanMaximumMovement")
	public Object getHumanMaximumMovement(){
		return repast.simphony.relogo.ReLogoModel.getInstance().getModelParam("humanMaximumMovement");
	}

	/**
	 * Sets the value of the global variable humanMaximumMovement.
	 *
	 * @param value
	 *            a value
	 */
	@ReLogoBuilderGeneratedFor("global: humanMaximumMovement")
	public void setHumanMaximumMovement(Object value){
		repast.simphony.relogo.ReLogoModel.getInstance().setModelParam("humanMaximumMovement",value);
	}

	/**
	 * Returns the value of the global variable mosquitoInitialInfectionProbability.
	 *
	 * @return the value of the global variable mosquitoInitialInfectionProbability
	 */
	@ReLogoBuilderGeneratedFor("global: mosquitoInitialInfectionProbability")
	public Object getMosquitoInitialInfectionProbability(){
		return repast.simphony.relogo.ReLogoModel.getInstance().getModelParam("mosquitoInitialInfectionProbability");
	}

	/**
	 * Sets the value of the global variable mosquitoInitialInfectionProbability.
	 *
	 * @param value
	 *            a value
	 */
	@ReLogoBuilderGeneratedFor("global: mosquitoInitialInfectionProbability")
	public void setMosquitoInitialInfectionProbability(Object value){
		repast.simphony.relogo.ReLogoModel.getInstance().setModelParam("mosquitoInitialInfectionProbability",value);
	}

	/**
	 * Returns the value of the global variable mosquitoInfectionPeriod.
	 *
	 * @return the value of the global variable mosquitoInfectionPeriod
	 */
	@ReLogoBuilderGeneratedFor("global: mosquitoInfectionPeriod")
	public Object getMosquitoInfectionPeriod(){
		return repast.simphony.relogo.ReLogoModel.getInstance().getModelParam("mosquitoInfectionPeriod");
	}

	/**
	 * Sets the value of the global variable mosquitoInfectionPeriod.
	 *
	 * @param value
	 *            a value
	 */
	@ReLogoBuilderGeneratedFor("global: mosquitoInfectionPeriod")
	public void setMosquitoInfectionPeriod(Object value){
		repast.simphony.relogo.ReLogoModel.getInstance().setModelParam("mosquitoInfectionPeriod",value);
	}

	/**
	 * Returns the value of the global variable mosquitoInfectionRadius.
	 *
	 * @return the value of the global variable mosquitoInfectionRadius
	 */
	@ReLogoBuilderGeneratedFor("global: mosquitoInfectionRadius")
	public Object getMosquitoInfectionRadius(){
		return repast.simphony.relogo.ReLogoModel.getInstance().getModelParam("mosquitoInfectionRadius");
	}

	/**
	 * Sets the value of the global variable mosquitoInfectionRadius.
	 *
	 * @param value
	 *            a value
	 */
	@ReLogoBuilderGeneratedFor("global: mosquitoInfectionRadius")
	public void setMosquitoInfectionRadius(Object value){
		repast.simphony.relogo.ReLogoModel.getInstance().setModelParam("mosquitoInfectionRadius",value);
	}

	/**
	 * Returns the value of the global variable mosquitoMaximumMovement.
	 *
	 * @return the value of the global variable mosquitoMaximumMovement
	 */
	@ReLogoBuilderGeneratedFor("global: mosquitoMaximumMovement")
	public Object getMosquitoMaximumMovement(){
		return repast.simphony.relogo.ReLogoModel.getInstance().getModelParam("mosquitoMaximumMovement");
	}

	/**
	 * Sets the value of the global variable mosquitoMaximumMovement.
	 *
	 * @param value
	 *            a value
	 */
	@ReLogoBuilderGeneratedFor("global: mosquitoMaximumMovement")
	public void setMosquitoMaximumMovement(Object value){
		repast.simphony.relogo.ReLogoModel.getInstance().setModelParam("mosquitoMaximumMovement",value);
	}

	/**
	 * Returns the value of the global variable numHumans.
	 *
	 * @return the value of the global variable numHumans
	 */
	@ReLogoBuilderGeneratedFor("global: numHumans")
	public Object getNumHumans(){
		return repast.simphony.relogo.ReLogoModel.getInstance().getModelParam("numHumans");
	}

	/**
	 * Sets the value of the global variable numHumans.
	 *
	 * @param value
	 *            a value
	 */
	@ReLogoBuilderGeneratedFor("global: numHumans")
	public void setNumHumans(Object value){
		repast.simphony.relogo.ReLogoModel.getInstance().setModelParam("numHumans",value);
	}

	/**
	 * Returns the value of the global variable numMosquitoes.
	 *
	 * @return the value of the global variable numMosquitoes
	 */
	@ReLogoBuilderGeneratedFor("global: numMosquitoes")
	public Object getNumMosquitoes(){
		return repast.simphony.relogo.ReLogoModel.getInstance().getModelParam("numMosquitoes");
	}

	/**
	 * Sets the value of the global variable numMosquitoes.
	 *
	 * @param value
	 *            a value
	 */
	@ReLogoBuilderGeneratedFor("global: numMosquitoes")
	public void setNumMosquitoes(Object value){
		repast.simphony.relogo.ReLogoModel.getInstance().setModelParam("numMosquitoes",value);
	}

	/**
	 * Returns the value of the global variable stopTime.
	 *
	 * @return the value of the global variable stopTime
	 */
	@ReLogoBuilderGeneratedFor("global: stopTime")
	public Object getStopTime(){
		return repast.simphony.relogo.ReLogoModel.getInstance().getModelParam("stopTime");
	}

	/**
	 * Sets the value of the global variable stopTime.
	 *
	 * @param value
	 *            a value
	 */
	@ReLogoBuilderGeneratedFor("global: stopTime")
	public void setStopTime(Object value){
		repast.simphony.relogo.ReLogoModel.getInstance().setModelParam("stopTime",value);
	}


}