package malaria.relogo

import static repast.simphony.relogo.Utility.*;
import static repast.simphony.relogo.UtilityG.*;
import repast.simphony.engine.environment.RunEnvironment
import repast.simphony.engine.schedule.ScheduledMethod
import repast.simphony.relogo.Stop;
import repast.simphony.relogo.Utility;
import repast.simphony.relogo.UtilityG;
import repast.simphony.relogo.schedule.Go;
import repast.simphony.relogo.schedule.Setup;
import malaria.ReLogoObserver;

class UserObserver extends ReLogoObserver {
    @ScheduledMethod(start = 0d)
	def setup(){
		clearAll()
		ask(patches()) {
			setPcolor(white())
		}
		setDefaultShape(Human, "person")
		createHumans(numHumans) {
			setxy(randomXcor(), randomYcor())
			init()
		}
		createMosquitoes(numMosquitoes) {
			setxy(randomXcor(), randomYcor())
			init()
		}
		RunEnvironment.getInstance().endAt(stopTime)
	}
	
	@ScheduledMethod(start = 1d, interval = 1d)
	def step() {
		ask(turtles()) {
			act()
		}
	}
	
	@ScheduledMethod(start = 1.5d, interval = 1d)
	def update() {
		ask(turtles()) {
			postStepUpdates()
		}

	}
}